# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from jsk_footstep_controller/SynchronizedForces.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import sensor_msgs.msg
import std_msgs.msg

class SynchronizedForces(genpy.Message):
  _md5sum = "9f34791d0775ccd699ccdfdb8b823128"
  _type = "jsk_footstep_controller/SynchronizedForces"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """Header header
geometry_msgs/WrenchStamped lleg_force
geometry_msgs/WrenchStamped rleg_force
sensor_msgs/JointState joint_angles
geometry_msgs/PointStamped zmp

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/WrenchStamped
# A wrench with reference coordinate frame and timestamp
Header header
Wrench wrench

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: geometry_msgs/PointStamped
# This represents a Point with reference coordinate frame and timestamp
Header header
Point point

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z
"""
  __slots__ = ['header','lleg_force','rleg_force','joint_angles','zmp']
  _slot_types = ['std_msgs/Header','geometry_msgs/WrenchStamped','geometry_msgs/WrenchStamped','sensor_msgs/JointState','geometry_msgs/PointStamped']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,lleg_force,rleg_force,joint_angles,zmp

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SynchronizedForces, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.lleg_force is None:
        self.lleg_force = geometry_msgs.msg.WrenchStamped()
      if self.rleg_force is None:
        self.rleg_force = geometry_msgs.msg.WrenchStamped()
      if self.joint_angles is None:
        self.joint_angles = sensor_msgs.msg.JointState()
      if self.zmp is None:
        self.zmp = geometry_msgs.msg.PointStamped()
    else:
      self.header = std_msgs.msg.Header()
      self.lleg_force = geometry_msgs.msg.WrenchStamped()
      self.rleg_force = geometry_msgs.msg.WrenchStamped()
      self.joint_angles = sensor_msgs.msg.JointState()
      self.zmp = geometry_msgs.msg.PointStamped()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.lleg_force.header.seq, _x.lleg_force.header.stamp.secs, _x.lleg_force.header.stamp.nsecs))
      _x = self.lleg_force.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_6d3I().pack(_x.lleg_force.wrench.force.x, _x.lleg_force.wrench.force.y, _x.lleg_force.wrench.force.z, _x.lleg_force.wrench.torque.x, _x.lleg_force.wrench.torque.y, _x.lleg_force.wrench.torque.z, _x.rleg_force.header.seq, _x.rleg_force.header.stamp.secs, _x.rleg_force.header.stamp.nsecs))
      _x = self.rleg_force.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_6d3I().pack(_x.rleg_force.wrench.force.x, _x.rleg_force.wrench.force.y, _x.rleg_force.wrench.force.z, _x.rleg_force.wrench.torque.x, _x.rleg_force.wrench.torque.y, _x.rleg_force.wrench.torque.z, _x.joint_angles.header.seq, _x.joint_angles.header.stamp.secs, _x.joint_angles.header.stamp.nsecs))
      _x = self.joint_angles.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.joint_angles.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_angles.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.joint_angles.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_angles.position))
      length = len(self.joint_angles.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_angles.velocity))
      length = len(self.joint_angles.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_angles.effort))
      _x = self
      buff.write(_get_struct_3I().pack(_x.zmp.header.seq, _x.zmp.header.stamp.secs, _x.zmp.header.stamp.nsecs))
      _x = self.zmp.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3d().pack(_x.zmp.point.x, _x.zmp.point.y, _x.zmp.point.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.lleg_force is None:
        self.lleg_force = geometry_msgs.msg.WrenchStamped()
      if self.rleg_force is None:
        self.rleg_force = geometry_msgs.msg.WrenchStamped()
      if self.joint_angles is None:
        self.joint_angles = sensor_msgs.msg.JointState()
      if self.zmp is None:
        self.zmp = geometry_msgs.msg.PointStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.lleg_force.header.seq, _x.lleg_force.header.stamp.secs, _x.lleg_force.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.lleg_force.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.lleg_force.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 60
      (_x.lleg_force.wrench.force.x, _x.lleg_force.wrench.force.y, _x.lleg_force.wrench.force.z, _x.lleg_force.wrench.torque.x, _x.lleg_force.wrench.torque.y, _x.lleg_force.wrench.torque.z, _x.rleg_force.header.seq, _x.rleg_force.header.stamp.secs, _x.rleg_force.header.stamp.nsecs,) = _get_struct_6d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.rleg_force.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.rleg_force.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 60
      (_x.rleg_force.wrench.force.x, _x.rleg_force.wrench.force.y, _x.rleg_force.wrench.force.z, _x.rleg_force.wrench.torque.x, _x.rleg_force.wrench.torque.y, _x.rleg_force.wrench.torque.z, _x.joint_angles.header.seq, _x.joint_angles.header.stamp.secs, _x.joint_angles.header.stamp.nsecs,) = _get_struct_6d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint_angles.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.joint_angles.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_angles.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.joint_angles.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_angles.position = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_angles.velocity = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_angles.effort = s.unpack(str[start:end])
      _x = self
      start = end
      end += 12
      (_x.zmp.header.seq, _x.zmp.header.stamp.secs, _x.zmp.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.zmp.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.zmp.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.zmp.point.x, _x.zmp.point.y, _x.zmp.point.z,) = _get_struct_3d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.lleg_force.header.seq, _x.lleg_force.header.stamp.secs, _x.lleg_force.header.stamp.nsecs))
      _x = self.lleg_force.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_6d3I().pack(_x.lleg_force.wrench.force.x, _x.lleg_force.wrench.force.y, _x.lleg_force.wrench.force.z, _x.lleg_force.wrench.torque.x, _x.lleg_force.wrench.torque.y, _x.lleg_force.wrench.torque.z, _x.rleg_force.header.seq, _x.rleg_force.header.stamp.secs, _x.rleg_force.header.stamp.nsecs))
      _x = self.rleg_force.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_6d3I().pack(_x.rleg_force.wrench.force.x, _x.rleg_force.wrench.force.y, _x.rleg_force.wrench.force.z, _x.rleg_force.wrench.torque.x, _x.rleg_force.wrench.torque.y, _x.rleg_force.wrench.torque.z, _x.joint_angles.header.seq, _x.joint_angles.header.stamp.secs, _x.joint_angles.header.stamp.nsecs))
      _x = self.joint_angles.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.joint_angles.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_angles.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.joint_angles.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_angles.position.tostring())
      length = len(self.joint_angles.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_angles.velocity.tostring())
      length = len(self.joint_angles.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_angles.effort.tostring())
      _x = self
      buff.write(_get_struct_3I().pack(_x.zmp.header.seq, _x.zmp.header.stamp.secs, _x.zmp.header.stamp.nsecs))
      _x = self.zmp.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3d().pack(_x.zmp.point.x, _x.zmp.point.y, _x.zmp.point.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.lleg_force is None:
        self.lleg_force = geometry_msgs.msg.WrenchStamped()
      if self.rleg_force is None:
        self.rleg_force = geometry_msgs.msg.WrenchStamped()
      if self.joint_angles is None:
        self.joint_angles = sensor_msgs.msg.JointState()
      if self.zmp is None:
        self.zmp = geometry_msgs.msg.PointStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.lleg_force.header.seq, _x.lleg_force.header.stamp.secs, _x.lleg_force.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.lleg_force.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.lleg_force.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 60
      (_x.lleg_force.wrench.force.x, _x.lleg_force.wrench.force.y, _x.lleg_force.wrench.force.z, _x.lleg_force.wrench.torque.x, _x.lleg_force.wrench.torque.y, _x.lleg_force.wrench.torque.z, _x.rleg_force.header.seq, _x.rleg_force.header.stamp.secs, _x.rleg_force.header.stamp.nsecs,) = _get_struct_6d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.rleg_force.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.rleg_force.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 60
      (_x.rleg_force.wrench.force.x, _x.rleg_force.wrench.force.y, _x.rleg_force.wrench.force.z, _x.rleg_force.wrench.torque.x, _x.rleg_force.wrench.torque.y, _x.rleg_force.wrench.torque.z, _x.joint_angles.header.seq, _x.joint_angles.header.stamp.secs, _x.joint_angles.header.stamp.nsecs,) = _get_struct_6d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint_angles.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.joint_angles.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_angles.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.joint_angles.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_angles.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_angles.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_angles.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      _x = self
      start = end
      end += 12
      (_x.zmp.header.seq, _x.zmp.header.stamp.secs, _x.zmp.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.zmp.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.zmp.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.zmp.point.x, _x.zmp.point.y, _x.zmp.point.z,) = _get_struct_3d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_6d3I = None
def _get_struct_6d3I():
    global _struct_6d3I
    if _struct_6d3I is None:
        _struct_6d3I = struct.Struct("<6d3I")
    return _struct_6d3I
